'use strict';

var jsxRuntime = require('react/jsx-runtime');
var React = require('react');
var AgGridUniversalFilter = require('ag-grid-universal-filter');
var reactCodeBlocks = require('react-code-blocks');
var agGridReact = require('ag-grid-react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var AgGridUniversalFilter__default = /*#__PURE__*/_interopDefaultLegacy(AgGridUniversalFilter);

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$2 = ".vmenu {\r\n  width: 150px;\r\n  display: flex;\r\n  flex-direction: column;\r\n  align-items: flex-start;\r\n  border-radius: 8px;\r\n  background-color: var(--pageColor2);\r\n  color: var(--compactSelectFontColor);\r\n}\r\n\r\n.vmenu-heading {\r\n  padding-top: 10px;\r\n  padding-bottom: 2px;\r\n  -webkit-margin-before: 0em;\r\n          margin-block-start: 0em;\r\n  -webkit-margin-after: 0em;\r\n          margin-block-end: 0em;\r\n  width: 100%;\r\n  font-weight: bold;\r\n  padding-left: 5px;\r\n}\r\n\r\n.vmenu-items {\r\n  width: 100%;\r\n  list-style-type: none;\r\n  -webkit-margin-before: 0px;\r\n          margin-block-start: 0px;\r\n  -webkit-margin-after: 0px;\r\n          margin-block-end: 0px;\r\n  -webkit-margin-start: 0px;\r\n          margin-inline-start: 0px;\r\n  -webkit-margin-end: 0px;\r\n          margin-inline-end: 0px;\r\n  -webkit-padding-start: 0px;\r\n          padding-inline-start: 0px;\r\n}\r\n\r\n.option {\r\n  padding-top: 1px;\r\n  padding-bottom: 1px;\r\n  -webkit-padding-start: 20px;\r\n          padding-inline-start: 20px;\r\n}\r\n";
styleInject(css_248z$2);

const VerticalMenu = ({ title, options, onSelect, }) => {
    const [active, setActive] = React.useState();
    const [highlight, setHighlight] = React.useState();
    return (jsxRuntime.jsxs("div", Object.assign({ className: "vmenu" }, { children: [jsxRuntime.jsx("h3", Object.assign({ className: "vmenu-heading" }, { children: title })), jsxRuntime.jsx("ul", Object.assign({ className: "vmenu-items" }, { children: options.map((option) => (jsxRuntime.jsx("li", Object.assign({ className: "option", style: {
                        backgroundColor: highlight === option || option === active
                            ? "var(--pageColor3)"
                            : "var(--pageColor2)",
                    }, onMouseEnter: () => setHighlight(option), onMouseLeave: () => setHighlight(undefined), onClick: () => {
                        setActive(option);
                        onSelect(option);
                    } }, { children: jsxRuntime.jsx("p", { children: option }) }), option))) }))] })));
};

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = React__default["default"].createContext && React__default["default"].createContext(DefaultContext);

var __assign = undefined && undefined.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = undefined && undefined.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function Tree2Element(tree) {
  return tree && tree.map(function (node, i) {
    return React__default["default"].createElement(node.tag, __assign({
      key: i
    }, node.attr), Tree2Element(node.child));
  });
}
function GenIcon(data) {
  // eslint-disable-next-line react/display-name
  return function (props) {
    return React__default["default"].createElement(IconBase, __assign({
      attr: __assign({}, data.attr)
    }, props), Tree2Element(data.child));
  };
}
function IconBase(props) {
  var elem = function (conf) {
    var attr = props.attr,
      size = props.size,
      title = props.title,
      svgProps = __rest(props, ["attr", "size", "title"]);
    var computedSize = size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + " " : "") + props.className;
    return React__default["default"].createElement("svg", __assign({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: __assign(__assign({
        color: props.color || conf.color
      }, conf.style), props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), title && React__default["default"].createElement("title", null, title), props.children);
  };
  return IconContext !== undefined ? React__default["default"].createElement(IconContext.Consumer, null, function (conf) {
    return elem(conf);
  }) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
function AiOutlineCode (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 1024 1024"},"child":[{"tag":"path","attr":{"d":"M516 673c0 4.4 3.4 8 7.5 8h185c4.1 0 7.5-3.6 7.5-8v-48c0-4.4-3.4-8-7.5-8h-185c-4.1 0-7.5 3.6-7.5 8v48zm-194.9 6.1l192-161c3.8-3.2 3.8-9.1 0-12.3l-192-160.9A7.95 7.95 0 0 0 308 351v62.7c0 2.4 1 4.6 2.9 6.1L420.7 512l-109.8 92.2a8.1 8.1 0 0 0-2.9 6.1V673c0 6.8 7.9 10.5 13.1 6.1zM880 112H144c-17.7 0-32 14.3-32 32v736c0 17.7 14.3 32 32 32h736c17.7 0 32-14.3 32-32V144c0-17.7-14.3-32-32-32zm-40 728H184V184h656v656z"}}]})(props);
}function AiOutlineCopy (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 1024 1024"},"child":[{"tag":"path","attr":{"d":"M832 64H296c-4.4 0-8 3.6-8 8v56c0 4.4 3.6 8 8 8h496v688c0 4.4 3.6 8 8 8h56c4.4 0 8-3.6 8-8V96c0-17.7-14.3-32-32-32zM704 192H192c-17.7 0-32 14.3-32 32v530.7c0 8.5 3.4 16.6 9.4 22.6l173.3 173.3c2.2 2.2 4.7 4 7.4 5.5v1.9h4.2c3.5 1.3 7.2 2 11 2H704c17.7 0 32-14.3 32-32V224c0-17.7-14.3-32-32-32zM350 856.2L263.9 770H350v86.2zM664 888H414V746c0-22.1-17.9-40-40-40H232V264h432v624z"}}]})(props);
}function AiOutlineEdit (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 1024 1024"},"child":[{"tag":"path","attr":{"d":"M257.7 752c2 0 4-.2 6-.5L431.9 722c2-.4 3.9-1.3 5.3-2.8l423.9-423.9a9.96 9.96 0 0 0 0-14.1L694.9 114.9c-1.9-1.9-4.4-2.9-7.1-2.9s-5.2 1-7.1 2.9L256.8 538.8c-1.5 1.5-2.4 3.3-2.8 5.3l-29.5 168.2a33.5 33.5 0 0 0 9.4 29.8c6.6 6.4 14.9 9.9 23.8 9.9zm67.4-174.4L687.8 215l73.3 73.3-362.7 362.6-88.9 15.7 15.6-89zM880 836H144c-17.7 0-32 14.3-32 32v36c0 4.4 3.6 8 8 8h784c4.4 0 8-3.6 8-8v-36c0-17.7-14.3-32-32-32z"}}]})(props);
}

var css_248z$1 = ".demo {\r\n  display: flex;\r\n  flex-direction: column;\r\n  align-items: flex-start;\r\n  -webkit-margin-after: 50px;\r\n          margin-block-end: 50px;\r\n  width: 100%;\r\n}\r\n\r\n.demo-title {\r\n  width: 100%;\r\n  -webkit-margin-before: 0;\r\n          margin-block-start: 0;\r\n  -webkit-margin-after: 0;\r\n          margin-block-end: 0;\r\n}\r\n\r\n.copy-text {\r\n  display: flex;\r\n  flex-direction: row;\r\n  align-items: center;\r\n  justify-content: stretch;\r\n  gap: 10px;\r\n  -webkit-margin-after: 20px;\r\n          margin-block-end: 20px;\r\n}\r\n\r\n.nospace {\r\n  -webkit-margin-before: 0px;\r\n          margin-block-start: 0px;\r\n  -webkit-margin-after: 0px;\r\n          margin-block-end: 0px;\r\n}\r\n\r\n.demo-point {\r\n  -webkit-margin-before: 0px;\r\n          margin-block-start: 0px;\r\n  -webkit-margin-after: 0px;\r\n          margin-block-end: 0px;\r\n  margin-left: 40px;\r\n}\r\n\r\n.demo-item {\r\n  display: flex;\r\n  flex-direction: row;\r\n  align-items: center;\r\n  justify-content: stretch;\r\n  gap: 10px;\r\n  width: 100%;\r\n  margin-bottom: 10px;\r\n}\r\n\r\n.demo-description {\r\n  flex: 1;\r\n  display: flex;\r\n  flex-direction: column;\r\n  justify-content: flex-start;\r\n  -webkit-margin-after: 10px;\r\n          margin-block-end: 10px;\r\n}\r\n\r\n.icons {\r\n  display: flex;\r\n  flex-direction: row;\r\n  justify-content: flex-start;\r\n  gap: 5px;\r\n  width: 100%;\r\n}\r\n\r\n.copy-wrapper {\r\n  position: relative;\r\n}\r\n\r\n.copied-text {\r\n  position: absolute;\r\n  background-color: white;\r\n  color: black;\r\n  top: -40px;\r\n  z-index: 1;\r\n}\r\n\r\n.code {\r\n  box-shadow: 5px 5px 10px 2px rgba(0, 0, 0, 0.8);\r\n}\r\n\r\n.icon-spin {\r\n  animation: spin-animation 0.5s infinite;\r\n  display: inline-block;\r\n}\r\n\r\n@keyframes spin-animation {\r\n  0% {\r\n    transform: rotate(0deg);\r\n  }\r\n  100% {\r\n    transform: rotate(359deg);\r\n  }\r\n}\r\n\r\n.icon-blink {\r\n  animation: blink 2s steps(5, start) infinite;\r\n  -webkit-animation: blink 1s steps(5, start) infinite;\r\n}\r\n@keyframes blink {\r\n  to {\r\n    visibility: hidden;\r\n  }\r\n}\r\n";
styleInject(css_248z$1);

const Demo = ({ description, points, props, code, sandbox, showAgGrid, complex }) => {
    const [showCode, setShowCode] = React.useState("");
    const [showCopied, setShowCopied] = React.useState(false);
    const [selected, setSelected] = React.useState([]);
    const [selectedDemo, setSelectedDemo] = React.useState("");
    const [rowData] = React.useState(complex !== null && complex !== void 0 ? complex : []);
    const [columnDefs] = React.useState([
        { field: "name", headerName: "Name", filter: "agSetColumnFilter", resizable: true, width: 100 },
        { field: "value", headerName: "Value", filter: "agNumberColumnFilter", resizable: true, width: 90 },
        { field: "description", headerName: "Description", filter: "agTextColumnFilter", resizable: true, width: 300 },
    ]);
    const [aggridApi, setAggridApi] = React.useState();
    const style = {
        height: "200px",
        width: "100%",
        "--ag-foreground-color": "var(--pageFont)",
        "--ag-background-color": "var(--pageColor5)",
        "--ag-header-foreground-color": "var(--universalSelectFontColor)",
        "--ag-header-background-color": "var(--pageColor2)",
        "--ag-odd-row-background-color": "var(--pageColor4)",
        "--ag-header-column-resize-handle-color": "var(--pageFont)"
    };
    const gridReady = (event) => {
        setAggridApi(event.api);
    };
    console.log(complex);
    return (jsxRuntime.jsxs("div", Object.assign({ className: "demo" }, { children: [jsxRuntime.jsx("h2", Object.assign({ className: "demo-title" }, { children: props.title })), jsxRuntime.jsxs("div", Object.assign({ className: "demo-description" }, { children: [jsxRuntime.jsx("p", { children: description }), points === null || points === void 0 ? void 0 : points.map((point, index) => jsxRuntime.jsx("p", Object.assign({ className: "demo-point" }, { children: point }), props.title + index))] })), jsxRuntime.jsxs("div", Object.assign({ className: "demo-item" }, { children: [jsxRuntime.jsx(AgGridUniversalFilter__default["default"], Object.assign({ onChange: sel => {
                            setSelected(sel);
                            setSelectedDemo(props.title);
                        }, agGridApi: showAgGrid ? aggridApi : undefined }, props), props.title), jsxRuntime.jsxs("div", Object.assign({ className: "icons" }, { children: [jsxRuntime.jsx(AiOutlineCode, { onClick: () => {
                                    setShowCode(showCode === props.title ? "" : props.title);
                                } }), jsxRuntime.jsxs("div", Object.assign({ className: "copy-wrapper" }, { children: [jsxRuntime.jsx(AiOutlineCopy, { onClick: () => {
                                            navigator.clipboard.writeText(code !== null && code !== void 0 ? code : "");
                                            setShowCopied(true);
                                            setTimeout(() => setShowCopied(false), 2000);
                                        } }), showCopied && jsxRuntime.jsx("p", Object.assign({ className: "copied-text" }, { children: "Copied" }))] })), jsxRuntime.jsx(AiOutlineEdit, { onClick: () => window.open(sandbox, "_blank") })] }))] })), jsxRuntime.jsxs("div", { children: [jsxRuntime.jsx("h6", Object.assign({ className: "nospace" }, { children: "Selection" })), jsxRuntime.jsx("p", Object.assign({ className: "nospace" }, { children: selectedDemo === props.title ? JSON.stringify(selected) : "" }), "selected" + props.title)] }), showAgGrid && jsxRuntime.jsx("div", Object.assign({ className: "ag-theme-alpine", style: style }, { children: jsxRuntime.jsx(agGridReact.AgGridReact, { rowData: rowData, columnDefs: columnDefs, onGridReady: gridReady }) })), showCode === props.title && (jsxRuntime.jsx("div", Object.assign({ className: "code" }, { children: jsxRuntime.jsx(reactCodeBlocks.CodeBlock, { width: "100%", text: code, language: "typescript", showLineNumbers: false, theme: reactCodeBlocks.googlecode }) })))] }), "demo" + props.title));
};

const formatDate = (date) => date.getDate() + '/' + (date.getMonth() + 1) + '/' + date.getFullYear();
const createExampleModel = ({ bigChoices, words, complex, typed }) => {
    const fetchItems = (text) => {
        return new Promise((resolve) => {
            setTimeout(() => {
                resolve(bigChoices.filter((item) => item.startsWith(text.toUpperCase())));
            }, Math.floor(Math.random() * 1500));
        });
    };
    const model = {
        categories: [
            {
                name: "Binding",
                demo: () => (jsxRuntime.jsxs("div", Object.assign({ className: "demo" }, { children: [jsxRuntime.jsx(Demo, { description: "The simpliest way to use the universal select - set the options to an array of strings", props: {
                                minWidth: "400px",
                                title: "Bind String",
                                choices: [
                                    {
                                        key: "Words",
                                        options: words,
                                    },
                                ],
                            }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          options: options,
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-string-binding-ooesy7" }), jsxRuntime.jsx(Demo, { description: "Universal select can be bound to objects", props: {
                                minWidth: "400px",
                                title: "Bind String",
                                choices: [
                                    {
                                        key: "Words",
                                        options: complex,
                                        text: (option) => option.name,
                                        value: (option) => option.value.toString(),
                                        search: "both"
                                    },
                                ],
                            }, code: `import UniversalSelect from "universal-select";
              import { options, Complex } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          options: options,
                          text: (option: Complex) => option.name,
                          value: (option: Complex) => option.value,
                          search: "both"
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-object-binding-forked-oripsu" }), jsxRuntime.jsx(Demo, { description: "Universal select can be bound to an object that implements OptionType", props: {
                                minWidth: "400px",
                                title: "Bind String",
                                choices: [
                                    {
                                        key: "Words",
                                        options: typed,
                                        search: "both"
                                    },
                                ],
                            }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          prefix: "words",
                          options: options,
                          search: "both"
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-typed-binding-forked-dqgq6g" })] }))),
            },
            {
                name: "Single Select",
                demo: () => (jsxRuntime.jsx("div", Object.assign({ className: "demo" }, { children: jsxRuntime.jsx(Demo, { description: "Limit users to one selection", props: {
                            minWidth: "400px",
                            title: "Single select",
                            choices: [
                                {
                                    key: "Words",
                                    options: words,
                                    maximumSelections: 1
                                },
                            ],
                        }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          options: options,
                          maximumSelections: 1
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-single-selection-forked-izdhxr" }) }))),
            },
            {
                name: "Multi Select",
                demo: () => (jsxRuntime.jsx("div", Object.assign({ className: "demo" }, { children: jsxRuntime.jsx(Demo, { description: "Limit users to 3 selections", props: {
                            minWidth: "400px",
                            title: "Multi Select",
                            choices: [
                                {
                                    key: "Words",
                                    prefix: "words",
                                    options: words,
                                    maximumSelections: 3
                                },
                            ],
                        }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          prefix: "words",
                          options: options,
                          maximumSelections: 3
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-multi-selection-forked-dg5vb2" }) }))),
            },
            {
                name: "Look-up",
                demo: () => (jsxRuntime.jsxs("div", Object.assign({ className: "demo" }, { children: [jsxRuntime.jsx(Demo, { description: "Use a promise to provide options", props: {
                                minWidth: "400px",
                                title: "Look-up",
                                choices: [
                                    {
                                        key: "Words",
                                        lookUp: fetchItems
                                    },
                                ],
                            }, code: `import UniversalSelect from "universal-select";
              import { fetchItems } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          prefix: "words",
                          lookUp: fetchItems
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-look-up-forked-r3upk7" }), jsxRuntime.jsx(Demo, { description: "Use a promise to provide and cache results", props: {
                                minWidth: "400px",
                                title: "Cache",
                                choices: [
                                    {
                                        key: "Words",
                                        lookUp: fetchItems
                                    }
                                ],
                                cacheLookUp: true
                            }, code: `import UniversalSelect from "universal-select";
              import { fetchItems } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          lookUp: fetchItems
                        }
                      ]}
                      cacheLookUp={true}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-look-up-cached-forked-1hdzzv" }), jsxRuntime.jsx(Demo, { description: "Use a promise to provide and cache results. Results expirr after specified time", props: {
                                minWidth: "400px",
                                title: "Expiry",
                                choices: [
                                    {
                                        key: "Words",
                                        lookUp: fetchItems
                                    }
                                ],
                                cacheLookUp: true,
                                cacheTimeToLive: 5,
                                cacheExpiryCheck: 5
                            }, code: `import UniversalSelect from "universal-select";
              import { fetchItems } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          lookUp: fetchItems
                        }
                      ]}
                      cacheLookUp={true}
                      cacheTimeToLive={5}
                      cacheExpiryCheck={5}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-look-up-cached-expire-forked-lldoph" })] }))),
            },
            {
                name: "Custom Values",
                demo: () => (jsxRuntime.jsxs("div", Object.assign({ className: "String" }, { children: [jsxRuntime.jsx(Demo, { description: "No list, just enter one of the below operators and enter a string. For example !%abc.", points: ["= (equals)", "! (not equals)", "% (contains)", "!% (not contains)", "%< (starts with)", "%> (ends with)", "& (and)", "| (or)"], props: {
                                minWidth: "400px",
                                title: "Custom Text",
                                choices: [
                                    {
                                        key: "Words",
                                        regExMatch: /.*/
                                    },
                                ],
                            }, code: `import UniversalSelect from "universal-select";
              import { fetchItems } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          regExMatch: /.*/
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-custom-values-scvyjk" }), jsxRuntime.jsx(Demo, { description: "No list, just enter one of the below operators and enter a string. For example <=.5.", points: ["= (equals)", "! (not equals)", "> (greater)", "< (less)", ">= (greater equal)", "<= (less equals)", "& (and)", "| (or)"], props: {
                                minWidth: "400px",
                                title: "Custom Number",
                                choices: [
                                    {
                                        key: "Words",
                                        regExMatch: /^\d{0,1}(\.\d{1,4})?$/,
                                        filterType: "number"
                                    }
                                ],
                                cacheLookUp: true
                            }, code: `import UniversalSelect from "universal-select";
    
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          regExMatch: /^\d{0,1}(\.\d{1,4})?$/,
                          filterType: "number"
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-custom-number-forked-d0eq1z" }), jsxRuntime.jsx(Demo, { description: "No list, just enter one of the below operators and enter a number. For example >50.", points: ["= (equals)", "! (not equals)", "> (greater)", "< (less)", "& (and)", "| (or)"], props: {
                                minWidth: "400px",
                                title: "Cusom Dateas",
                                choices: [
                                    {
                                        key: "Words",
                                        regExMatch: /^[0-9]{0,2}$/,
                                        valueGetter: (text) => {
                                            const now = new Date();
                                            const years = parseInt(text);
                                            return formatDate(new Date(now.setFullYear(now.getFullYear() + years)));
                                        },
                                        filterType: "date"
                                    }
                                ],
                                cacheLookUp: true
                            }, code: `import UniversalSelect from "universal-select";
    
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          regExMatch: /^[0-9]{0,2}$/,
                          valueGetter: (text: string) => {
                            const now = new Date();
                            const years = parseInt(text);
                            return formatDate(
                              new Date(now.setFullYear(now.getFullYear() + years))
                            );
                          },
                          filterType: "date"
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-custom-dates-forked-3ijv6h" })] }))),
            },
            {
                name: "Selection prefixed",
                demo: () => (jsxRuntime.jsx("div", Object.assign({ className: "demo" }, { children: jsxRuntime.jsx(Demo, { description: "Limit users to one selection", props: {
                            minWidth: "400px",
                            title: "Prefixed",
                            choices: [
                                {
                                    prefix: "Words",
                                    key: "Words",
                                    options: words
                                },
                            ]
                        }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          prefix: "Words",
                          key: "Words",
                          options: options
                        }
                      ]}
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-no-prefix-b9c2kf" }) }))),
            },
            {
                name: "Disabled",
                demo: () => (jsxRuntime.jsx("div", Object.assign({ className: "demo" }, { children: jsxRuntime.jsx(Demo, { description: "Limit users to one selection", props: {
                            minWidth: "400px",
                            title: "Disabled",
                            choices: [
                                {
                                    key: "Words",
                                    options: words
                                },
                            ],
                            disabled: true
                        }, code: `import UniversalSelect from "universal-select";
              import { options } from "./data";
              
              import "./styles.css";
              
              export default function App() {
                return (
                  <div className="Space">
                    <UniversalSelect
                      title="test"
                      choices={[
                        {
                          key: "Words",
                          options: options
                        }
                      ]}
                      disabled
                    />
                  </div>
                );
              }`, sandbox: "https://codesandbox.io/s/universal-disabled-zrbojv" }) }))),
            }
        ],
        constructDemo: (demoName) => {
            const category = model.categories.find((cat) => cat.name === demoName);
            return category ? category === null || category === void 0 ? void 0 : category.demo() : jsxRuntime.jsx("div", {});
        }
    };
    return model;
};

var css_248z = ".examples {\r\n  display: flex;\r\n  flex-direction: row;\r\n  margin-top: 20px;\r\n  margin-bottom: 20px;\r\n  color: var(--pageFont);\r\n}\r\n\r\n.controls {\r\n  flex: 1;\r\n  padding: 25px;\r\n  height: 100%;\r\n  min-height: 700px;\r\n}\r\n\r\n.demo {\r\n  display: flex;\r\n  flex-direction: column;\r\n  align-items: flex-start;\r\n  -webkit-margin-after: 50px;\r\n          margin-block-end: 50px;\r\n  width: 100%;\r\n}";
styleInject(css_248z);

const Examples = (props) => {
    const [demo, setDemo] = React.useState();
    const model = React.useMemo(() => createExampleModel(props), []);
    return (jsxRuntime.jsxs("div", Object.assign({ className: "examples" }, { children: [jsxRuntime.jsx(VerticalMenu, { title: "Catagories", options: model.categories.map((c) => c.name), onSelect: setDemo }), jsxRuntime.jsx("div", Object.assign({ className: "controls" }, { children: demo && model.constructDemo(demo) }))] })));
};

module.exports = Examples;
